using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.ProductGroup.Cqrs;

public class GetProductGroupByIdResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetProductGroupByIdQuery(string Id) : IRequest<GetProductGroupByIdResponse?>;

public class GetProductGroupByIdHandler : IRequestHandler<GetProductGroupByIdQuery, GetProductGroupByIdResponse?>
{
    private readonly AppDbContext _context;

    public GetProductGroupByIdHandler(AppDbContext context) => _context = context;

    public async Task<GetProductGroupByIdResponse?> Handle(GetProductGroupByIdQuery request, CancellationToken cancellationToken)
    {
        return await _context.ProductGroup
            .AsNoTracking()
            .Where(x => x.Id == request.Id)
            .Select(x => new GetProductGroupByIdResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .FirstOrDefaultAsync(cancellationToken);
    }
}